//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  Red
#property indicator_color2  Blue
#property indicator_color3  Green
#property indicator_style3  STYLE_DOT
#property indicator_color4  Brown
#property indicator_style4  STYLE_DOT
#property indicator_color5  Lavender
#property indicator_color6  Green
#property indicator_style6  STYLE_DASH
#property indicator_color7  Brown
#property indicator_style7  STYLE_DASH

//
//
//
//
//

extern int    Tenkan       = 9;
extern int    Kijun        = 26;
extern int    Senkou       = 52;
extern int    ChinkouShift = -26;

//
//
//
//
//

double Tenkan_Buffer[];
double Kijun_Buffer[];
double SpanA_Buffer[];
double SpanB_Buffer[];
double Chinkou_Buffer[];
double SpanA2_Buffer[];
double SpanB2_Buffer[];

//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   
     SetIndexBuffer(0,Tenkan_Buffer);                                  SetIndexLabel(0,"Tenkan Sen");
     SetIndexBuffer(1,Kijun_Buffer);                                   SetIndexLabel(1,"Kijun Sen");
     SetIndexBuffer(2,SpanA_Buffer);  SetIndexStyle(2,DRAW_HISTOGRAM); 
     SetIndexBuffer(3,SpanB_Buffer);  SetIndexStyle(3,DRAW_HISTOGRAM); 
     SetIndexBuffer(4,Chinkou_Buffer);                                 SetIndexLabel(4,"Chinkou Span");
     SetIndexBuffer(5,SpanA2_Buffer);                                  SetIndexLabel(5,"Senkou Span A");
     SetIndexBuffer(6,SpanB2_Buffer);                                  SetIndexLabel(6,"Senkou Span B");
     
     SetIndexShift(2,Kijun);  
     SetIndexShift(3,Kijun);  
     SetIndexShift(4,ChinkouShift); 
     SetIndexShift(5,Kijun);
     SetIndexShift(6,Kijun);       
     
     IndicatorShortName("Ichimoku2");
     
return(0);
}

//
//
//
//
//

int deinit() {  return(0);}

//
//
//
//                           
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;
   
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
       
       double thi    = High[i];
       double tlo    = Low[i];
       double tprice = 0;
       if (i >= Bars - Tenkan) continue;
       for(k = 1; k < Tenkan; k++)
       {
           tprice = High[i+k];
           if(thi < tprice)  thi = tprice;
         
           tprice = Low[i+k];
           if(tlo  > tprice) tlo = tprice;
       }
       
       if ((thi+tlo) > 0.0) 
            Tenkan_Buffer[i] = (thi + tlo)/2; 
       else Tenkan_Buffer[i] = 0;
       
       //
       //
       //
       //
       //
       
       double khi    = High[i];
       double klo    = Low[i];
       double kprice = 0;
       if  (i >= Bars - Kijun) continue;
       for (k = 1; k < Kijun; k++)
       {
          kprice = High[i+k];
          if(khi < kprice)  khi  = kprice;
         
          kprice = Low[i+k];
          if(klo  > kprice) klo  = kprice;
       }
        
       if ((khi+klo) > 0.0) 
            Kijun_Buffer[i] = (khi + klo)/2; 
       else Kijun_Buffer[i] = 0;
            
       //
       //
       //
       //
       //
        
       double shigh  = High[i];
       double slow   = Low[i];
       double sprice = 0;
       if (i >= Bars - Senkou) continue;
       for(k = 1; k < Senkou; k++)
       {
           sprice = High[i+k];
           if(shigh < sprice) shigh = sprice;
         
           sprice = Low[i+k];
           if(slow  > sprice) slow  = sprice;
        }
        
        SpanA_Buffer[i]   = (Kijun_Buffer[i] + Tenkan_Buffer[i])/2;
        SpanA2_Buffer[i]  = (Kijun_Buffer[i] + Tenkan_Buffer[i])/2;
        SpanB_Buffer[i]   = (shigh + slow)/2;             
        SpanB2_Buffer[i]  = (shigh + slow)/2;             
        Chinkou_Buffer[i] =  Close[i];                  
   }
return(0);
}
  
  